#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7, INF = 2e9;

int add(int a, int b){
    int c = a + b;
    if(c >= MOD) c -= MOD;
    return c;
}

int mult(int a, int b){
    return (1ll * a * b) % MOD;
}

int n;

bool flag;

vector<vector<int>> tree, cnt, mn, mx;
vector<int> vals;

void dfs(int v, int p){
    int nodecnt = 1;

    for(auto e : tree[v]){
        if(e != p){
            dfs(e, v);

            nodecnt += (int)cnt[e].size() - 1;
        }
    }

    cnt[v].assign(nodecnt + 1, 0);
    mn[v].assign(nodecnt + 1, INF);
    mx[v].assign(nodecnt + 1, -INF);

    cnt[v][1] = 1, mn[v][1] = vals[v], mx[v][1] = vals[v];

    nodecnt = 1;

    for(auto e : tree[v]){
        if(e != p){
            for(int prv = nodecnt; prv >= 1; prv--){
                for(int cur = 1; cur <= (int)cnt[e].size() - 1; cur++){
                    cnt[v][prv + cur] = add(cnt[v][prv + cur], mult(cnt[v][prv], cnt[e][cur]));
                    mn[v][prv + cur] = min(mn[v][prv + cur], mn[v][prv] + mn[e][cur]);
                    mx[v][prv + cur] = max(mx[v][prv + cur], mx[v][prv] + mx[e][cur]);
                }
            }

            nodecnt += (int)cnt[e].size() - 1;
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> flag;

    tree.assign(n + 1, {});

    for(int i = 0; i < n - 1; i++){
        int a, b;

        cin >> a >> b;

        tree[a].push_back(b);
        tree[b].push_back(a);
    }

    vals.assign(n + 1, 0);

    for(int i = 1; i <= n; i++) cin >> vals[i];

    cnt = mn = mx = vector<vector<int>>(n + 1, vector<int>{});

    dfs(1, 0);

    for(int k = 1; k <= n; k++){
        int curcnt = 0, curmn = INF, curmx = -INF;

        for(int v = 1; v <= n; v++){
            if(k < cnt[v].size()){
                curcnt = add(curcnt, cnt[v][k]);
                curmn = min(curmn, mn[v][k]);
                curmx = max(curmx, mx[v][k]);
            }
        }

        if(flag) cout << curcnt << " " << curmn << " " << curmx << "\n";
        else cout << curcnt << "\n";
    }
}
